#include <stdio.h>
#include <stdlib.h>

#include "gd_graph.h"
#include "gd_utils.h"

char * progname;

void usage(){
  fprintf(stderr,"usage: %s dumpfile nodenumber\n",progname);
  fprintf(stderr,"0 < nodenumber < num_nodes_in_file\n");
  exit(1);
}

int main(int argc, char * argv[]){
  gd_graph g;
  char * filename;
  int nodenum,i,j,printed;
  progname = argv[0];

  if (argc != 3) {
    usage();
  }

  filename = argv[1];
  nodenum = atoi(argv[2]);
  g = gd_graph_read_binary_file(filename,1.0,1.0,1.0);
  if (g.curStringPos == 0) {
    fprintf(stderr,"could not get graph\n");
    exit(1);
  }

  for(i =0; i< g.curNodePos; i++){
    g.nodeBuffer[i].common.mark_flag1 = 0;
  }

  printed = 0;
  while((j = UsedBy(g,nodenum,1)) != -1){
    if (!printed){
      printf("node %d is used by:\n",nodenum);
      printed = 1;
    }
    printf(" %d\n",j);
    g.nodeBuffer[j].common.mark_flag1 = 1;
  }
  if(!printed) {
      printf("node %d is not used by any node\n");
  }


  return 0;
}
